# Create equity or token tax event

POST https://api.letsdeel.com/rest/v2/equities-tokens/tax-events
Content-Type: application/json

Use this endpoint to submit an equity or token tax event for an EOR onboarded to Equity & Token Services
 **Token scopes**: `equities:write`

Reference: https://developer.deel.com/api/reference/endpoints/equity-tokens/create-equity-or-token-tax-event

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: Deel HRIS SCIM API
  version: 1.0.0
paths:
  /equities-tokens/tax-events:
    post:
      operationId: create-equity-or-token-tax-event
      summary: Create equity or token tax event
      description: >-
        Use this endpoint to submit an equity or token tax event for an EOR
        onboarded to Equity & Token Services
         **Token scopes**: `equities:write`
      tags:
        - subpackage_equityTokens
      parameters:
        - name: Authorization
          in: header
          description: >
            ## Authentication

            The Deel API uses bearer tokens to authenticate requests. All API
            calls must be made over HTTPS — calls over plain HTTP or without
            authentication will fail.


            ```curl

            curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \
              -H 'Authorization: Bearer YOUR-TOKEN-HERE'
            ```


            [Learn more about authentication](/api/authentication)
          required: true
          schema:
            type: string
      responses:
        '201':
          description: Successful operation.
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/Equity
                  Tokens_createEquityOrTokenTaxEvent_Response_201
        '400':
          description: Bad request
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/CreateEquityOrTokenTaxEventRequestBadRequestError
        '401':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '403':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '404':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '500':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                data:
                  $ref: >-
                    #/components/schemas/EquitiesTokensTaxEventsPostRequestBodyContentApplicationJsonSchemaData
servers:
  - url: https://api.letsdeel.com/rest/v2
  - url: https://api-staging.letsdeel.com/rest/v2
components:
  schemas:
    EquitiesTokensTaxEventsPostRequestBodyContentApplicationJsonSchemaDataMethodOfTaxCoverage:
      type: string
      enum:
        - AD_HOC
        - BIK_REPORTING_ONLY
        - BIK_WITHHOLDING_AT_SOURCE_CLIENT
        - BIK_WITHHOLDING_AT_SOURCE_CLIENT_REVERSE
        - BIK_WITHHOLDING_GROSSED_UP_BONUS
        - BIK_WITHHOLDING_NET_SETTLEMENT
        - BIK_WITHHOLDING_SALARY_DEDUCTION
        - BIK_WITHHOLDING_WORKER
        - NO_BIK_NO_WITHHOLDING
      description: The method used to cover the taxes
      title: >-
        EquitiesTokensTaxEventsPostRequestBodyContentApplicationJsonSchemaDataMethodOfTaxCoverage
    EquitiesTokensTaxEventsPostRequestBodyContentApplicationJsonSchemaData:
      type: object
      properties:
        fx_rate:
          type: number
          format: double
          description: >-
            The exchange rate used to convert the local currency to the payroll
            currency
        tax_rate:
          type: number
          format: double
          description: The tax rate applied to the benefit in kind
        unit_fmv:
          type: number
          format: double
          description: >-
            The fair market value of the equity/token grant at the time of the
            event
        event_date:
          type: string
          format: date
          description: The date of the event
        sale_price:
          type: number
          format: double
          description: The price at which the equity/token was sold
        contract_id:
          type: string
          description: >-
            The unique identifier of the contract of the employee who received
            the equity/token grant
        gross_value:
          type: number
          format: double
          description: The gross value of the equity/token grant
        plan_currency:
          type: string
          description: The currency in which the equity/token grant was issued
        exercise_price:
          type: number
          format: double
          description: The price at which the equity/token was exercised
        equity_grant_id:
          type: string
          description: >-
            The unique identifier of the equity/token grant - optional in case
            you don't have remove the property
        settlement_date:
          type: string
          format: date
          description: The date of the settlement
        payroll_currency:
          type: string
          description: The currency in which the payroll is processed
        tax_jurisdiction:
          type: string
          description: The tax jurisdiction in which the equity/token grant was issued
        transaction_fees:
          type: number
          format: double
          description: The fees associated with the transaction
        quantity_remaining:
          type: number
          format: double
          description: The quantity of equity/token that remains
        taxable_gain_or_loss:
          type: number
          format: double
          description: The taxable gain or loss
        total_exercise_price:
          type: number
          format: double
          description: The total exercise price
        total_taxes_withheld:
          type: number
          format: double
          description: The total amount of taxes withheld
        method_of_tax_coverage:
          $ref: >-
            #/components/schemas/EquitiesTokensTaxEventsPostRequestBodyContentApplicationJsonSchemaDataMethodOfTaxCoverage
          description: The method used to cover the taxes
        quantity_withheld_or_sold:
          type: number
          format: double
          description: The quantity of equity/token that was withheld or sold
        withheld_tax_local_currency:
          type: number
          format: double
          description: The tax withheld in the local currency
        benefit_in_kind_local_currency:
          type: number
          format: double
          description: The benefit in kind in the local currency
        quantity_exercised_or_released:
          type: number
          format: double
          description: The quantity of equity/token that was exercised or released
      required:
        - fx_rate
        - contract_id
        - plan_currency
        - settlement_date
        - payroll_currency
        - tax_jurisdiction
        - taxable_gain_or_loss
        - total_taxes_withheld
        - method_of_tax_coverage
        - withheld_tax_local_currency
        - benefit_in_kind_local_currency
      title: EquitiesTokensTaxEventsPostRequestBodyContentApplicationJsonSchemaData
    EquitiesTokensTaxEventsPostResponsesContentApplicationJsonSchemaData:
      type: object
      properties:
        id:
          type: string
          format: uuid
          description: the id of the equity/token tax event generated
        created_at:
          type: string
          format: date-time
          description: the date and time when the equity/token tax event was created
      title: EquitiesTokensTaxEventsPostResponsesContentApplicationJsonSchemaData
    Equity Tokens_createEquityOrTokenTaxEvent_Response_201:
      type: object
      properties:
        data:
          $ref: >-
            #/components/schemas/EquitiesTokensTaxEventsPostResponsesContentApplicationJsonSchemaData
      title: Equity Tokens_createEquityOrTokenTaxEvent_Response_201
    EquitiesTokensTaxEventsPostResponsesContentApplicationJsonSchemaErrorsItems:
      type: object
      properties:
        code:
          type: string
          description: return code error
        field:
          type: string
          description: field that caused the error
        message:
          type: string
          description: description of the error
      title: >-
        EquitiesTokensTaxEventsPostResponsesContentApplicationJsonSchemaErrorsItems
    CreateEquityOrTokenTaxEventRequestBadRequestError:
      type: object
      properties:
        errors:
          type: array
          items:
            $ref: >-
              #/components/schemas/EquitiesTokensTaxEventsPostResponsesContentApplicationJsonSchemaErrorsItems
      title: CreateEquityOrTokenTaxEventRequestBadRequestError
    ApiErrorRequest:
      type: object
      properties:
        method:
          type: string
          description: The HTTP method of the failed request
        url:
          type: string
          description: The relative URL of the failed request
        status:
          type: number
          format: double
          description: The status code of the response
        api_req_id:
          type: string
          description: The request ID of the failed request
        docs:
          type: string
          description: >-
            A link to the official documentation for the requested endpoint
            resource
        source:
          type: string
          description: The source handler which produced the returned error
        code:
          type: number
          format: double
          description: The code of the source handler which produced the returned error
      title: ApiErrorRequest
    ApiError:
      type: object
      properties:
        message:
          type: string
          description: A description of the returned error
        path:
          type: string
          description: The JSON path where input validation failed
      title: ApiError
    ApiErrorContainer:
      type: object
      properties:
        request:
          $ref: '#/components/schemas/ApiErrorRequest'
        errors:
          type: array
          items:
            $ref: '#/components/schemas/ApiError'
      title: ApiErrorContainer
  securitySchemes:
    deelToken:
      type: http
      scheme: bearer
      description: >
        ## Authentication

        The Deel API uses bearer tokens to authenticate requests. All API calls
        must be made over HTTPS — calls over plain HTTP or without
        authentication will fail.


        ```curl

        curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \
          -H 'Authorization: Bearer YOUR-TOKEN-HERE'
        ```


        [Learn more about authentication](/api/authentication)
    oauth2:
      type: http
      scheme: bearer
      description: >-
        Standard OAuth2 security scheme based on
        https://swagger.io/docs/specification/authentication/

```

## SDK Code Examples

```python
import requests

url = "https://api.letsdeel.com/rest/v2/equities-tokens/tax-events"

payload = {}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.letsdeel.com/rest/v2/equities-tokens/tax-events';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.letsdeel.com/rest/v2/equities-tokens/tax-events"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.letsdeel.com/rest/v2/equities-tokens/tax-events")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.letsdeel.com/rest/v2/equities-tokens/tax-events")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.letsdeel.com/rest/v2/equities-tokens/tax-events', [
  'body' => '{}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.letsdeel.com/rest/v2/equities-tokens/tax-events");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.letsdeel.com/rest/v2/equities-tokens/tax-events")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```